package com.company.testexportexcel.screen.testdataforexport;

import io.jmix.core.DataManager;
import io.jmix.core.SaveContext;
import io.jmix.ui.component.Button;
import io.jmix.ui.model.CollectionContainer;
import io.jmix.ui.model.CollectionLoader;
import io.jmix.ui.screen.*;
import com.company.testexportexcel.entity.TestDataForExport;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.Objects;

@UiController("TestDataForExport.browse")
@UiDescriptor("test-data-for-export-browse.xml")
@LookupComponent("testDataForExportsTable")
public class TestDataForExportBrowse extends StandardLookup<TestDataForExport> {
    @Autowired
    private DataManager dataManager;
    @Autowired
    private CollectionContainer<TestDataForExport> testDataForExportsDc;


    private void generateTestData(){
        SaveContext saveContext = new SaveContext();
        for (int i = 0; i < 1000; i++) {
            TestDataForExport testDataForExport = dataManager.create(TestDataForExport.class);
            testDataForExport.setText(String.join(" ","test",String.valueOf(i)));
            testDataForExport.setNumber(i);
            saveContext.saving(testDataForExport);
        }
        dataManager.save(saveContext);
    }

    @Subscribe("generateBtn")
    public void onGenerateBtnClick(final Button.ClickEvent event) {
        dataManager.loadValue("select COUNT(t) from TestDataForExport t", Integer.class).optional().ifPresent(count -> {
            if (count < 1000) {
                generateTestData();
            }
        });
    }
}